#ifndef PIXELBITMAP_H
#define PIXELBITMAP_H

#ifndef _BE_H
#error Need the precompiled header BeHeaders.pch++ !
#endif

//PC #include "Point.h"
//PC #include "Rect.h"
//PC #include "allegro.h"

struct PixelSprite : public BObject
{
	int width,height;
	uchar *data;
//PC	BITMAP *bitmap;

	PixelSprite() { width=height=0; data=NULL; }
//PC	PixelSprite() { bitmap=NULL; };

};

class PixelBitmap : public BBitmap
{
private:

//PC	BRect fBounds;

public:

//PC	BITMAP *bitmap;

	uchar *fBits;
	int fBpr;

	PixelBitmap(BRect bounds);

//PC	~PixelBitmap();
	
/*PC
	void *Bits() const
	{ return (void *)(bitmap->line[0]); };
	
	long BytesPerRow()
	{ return long(bitmap->line[1]-bitamp->line[0]); };
	
	BRect Bounds() const
	{ return fBounds; };
	
PC*/
	
	static PixelBitmap* FromPCX(char *filename);
	static PixelBitmap* FromPCX(record_ref ref);
	
	void Clear(uchar color);
	
	inline void SetPixel(int x,int y,uchar color);
	inline void _SetPixel(int x,int y,uchar color);
		
	void Box(BRect rect,uchar col);
	inline void Box(int left,int top,int right,int bottom,uchar col)
	{ Box(BRect(left,top,right,bottom),col); };

	void IncBox(int left,int top,int right,int bottom);
	void DecBox(int left,int top,int right,int bottom);
	
	inline void PutSprite(PixelSprite *spr,BPoint where)
	{ PutSprite(spr,int(where.x),int(where.y)); };
	
	void PutSprite(PixelSprite *spr,int x,int y);
	
};

void PixelBitmap::SetPixel(int x,int y,uchar color)
{
	int offset=y*BytesPerRow()+x;
	if (offset>=0 && offset<BitsLength())
		fBits[offset] = color;
}

// no check
void PixelBitmap::_SetPixel(int x,int y,uchar color)
{
	fBits[y*BytesPerRow()+x] = color;
}

#endif // PIXELBITMAP_H