#include "Balls.h"

BallsWindow::BallsWindow(BRect frame)
: BWindow(frame,"Balls",B_TITLED_WINDOW,B_FRAME_EVENTS)
{
	SetDiscipline(false); // boost

	BRect full(0,0,Bounds().right+100,Bounds().bottom+100);

	SetSizeLimits(16,full.right,
		16,full.bottom);

	BView *aView =
		new BallsView(full);
		
	AddChild(aView);
	aView->ResizeTo(Bounds().right,Bounds().bottom);
		
}

bool BallsWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

#ifdef SCREEN
void BallsWindow::FrameMoved(BPoint screenpoint)
{

#pragma unused (screenpoint)

	((BallsView *)ChildAt(0))->WindowMoved();	
}
#endif